Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -3,4 +3,6 @@
  *
  * Some code copyright (C) 2002-2004, Philip S Tellis <philip.tellis AT gmx.net>
+ * YMSG16 code copyright (C) 2009, 
+ * 		Siddhesh Poyarekar <siddhesh dot poyarekar at gmail dot com>
  *
  * Yahoo Search copyright (C) 2003, Konstantin Klyagin <konst AT konst.org.ua>
@@ -27,4 +29,6 @@
  *     <hiro-y@kcn.ne.jp>
  *
+ * YMSG16 authentication code based mostly on write-up at:
+ * 	http://www.carbonize.co.uk/ymsg16.html
  *
  * This program is free software; you can redistribute it and/or modify
@@ -92,7 +96,7 @@
 
 #ifdef USE_STRUCT_CALLBACKS
-struct yahoo_callbacks *yc=NULL;
-
-void yahoo_register_callbacks(struct yahoo_callbacks * tyc)
+struct yahoo_callbacks *yc = NULL;
+
+void yahoo_register_callbacks(struct yahoo_callbacks *tyc)
 {
 	yc = tyc;
@@ -104,7 +108,9 @@
 #endif
 
-static int yahoo_send_data(int fd, void *data, int len);
-
-int yahoo_log_message(char * fmt, ...)
+static int yahoo_send_data(void *fd, void *data, int len);
+static void _yahoo_http_connected(int id, void *fd, int error, void *data);
+static void yahoo_connected(void *fd, int error, void *data);
+
+int yahoo_log_message(char *fmt, ...)
 {
 	char out[1024];
@@ -113,10 +119,10 @@
 	vsnprintf(out, sizeof(out), fmt, ap);
 	va_end(ap);
-	return YAHOO_CALLBACK(ext_yahoo_log)("%s", out);
-}
-
-int yahoo_connect(char * host, int port)
-{
-	return YAHOO_CALLBACK(ext_yahoo_connect)(host, port);
+	return YAHOO_CALLBACK(ext_yahoo_log) ("%s", out);
+}
+
+int yahoo_connect(char *host, int port)
+{
+	return YAHOO_CALLBACK(ext_yahoo_connect) (host, port);
 }
 
@@ -136,95 +142,28 @@
 
 /* default values for servers */
-static char pager_host[] = "scs.msg.yahoo.com"; 
+static char *default_pager_hosts[] = {	"scs.msg.yahoo.com",
+					"scsa.msg.yahoo.com",
+					"scsb.msg.yahoo.com",
+					"scsc.msg.yahoo.com",
+					NULL};
+
 static int pager_port = 5050;
-static int fallback_ports[]={23, 25, 80, 20, 119, 8001, 8002, 5050, 0};
-static char filetransfer_host[]="filetransfer.msg.yahoo.com";
-static int filetransfer_port=80;
-static char webcam_host[]="webcam.yahoo.com";
-static int webcam_port=5100;
-static char webcam_description[]="";
-static char local_host[]="";
-static int conn_type=Y_WCM_DSL;
+static int fallback_ports[] = { 23, 25, 80, 20, 119, 8001, 8002, 5050, 0 };
+
+static char filetransfer_host[] = "filetransfer.msg.yahoo.com";
+static int filetransfer_port = 80;
+static char webcam_host[] = "webcam.yahoo.com";
+static int webcam_port = 5100;
+static char webcam_description[] = "";
+static char local_host[] = "";
+static int conn_type = Y_WCM_DSL;
 
 static char profile_url[] = "http://profiles.yahoo.com/";
 
-enum yahoo_service { /* these are easier to see in hex */
-	YAHOO_SERVICE_LOGON = 1,
-	YAHOO_SERVICE_LOGOFF,
-	YAHOO_SERVICE_ISAWAY,
-	YAHOO_SERVICE_ISBACK,
-	YAHOO_SERVICE_IDLE, /* 5 (placemarker) */
-	YAHOO_SERVICE_MESSAGE,
-	YAHOO_SERVICE_IDACT,
-	YAHOO_SERVICE_IDDEACT,
-	YAHOO_SERVICE_MAILSTAT,
-	YAHOO_SERVICE_USERSTAT, /* 0xa */
-	YAHOO_SERVICE_NEWMAIL,
-	YAHOO_SERVICE_CHATINVITE,
-	YAHOO_SERVICE_CALENDAR,
-	YAHOO_SERVICE_NEWPERSONALMAIL,
-	YAHOO_SERVICE_NEWCONTACT,
-	YAHOO_SERVICE_ADDIDENT, /* 0x10 */
-	YAHOO_SERVICE_ADDIGNORE,
-	YAHOO_SERVICE_PING,
-	YAHOO_SERVICE_GOTGROUPRENAME, /* < 1, 36(old), 37(new) */
-	YAHOO_SERVICE_SYSMESSAGE = 0x14,
-	YAHOO_SERVICE_SKINNAME = 0x15,
-	YAHOO_SERVICE_PASSTHROUGH2 = 0x16,
-	YAHOO_SERVICE_CONFINVITE = 0x18,
-	YAHOO_SERVICE_CONFLOGON,
-	YAHOO_SERVICE_CONFDECLINE,
-	YAHOO_SERVICE_CONFLOGOFF,
-	YAHOO_SERVICE_CONFADDINVITE,
-	YAHOO_SERVICE_CONFMSG,
-	YAHOO_SERVICE_CHATLOGON,
-	YAHOO_SERVICE_CHATLOGOFF,
-	YAHOO_SERVICE_CHATMSG = 0x20,
-	YAHOO_SERVICE_GAMELOGON = 0x28,
-	YAHOO_SERVICE_GAMELOGOFF,
-	YAHOO_SERVICE_GAMEMSG = 0x2a,
-	YAHOO_SERVICE_FILETRANSFER = 0x46,
-	YAHOO_SERVICE_VOICECHAT = 0x4A,
-	YAHOO_SERVICE_NOTIFY,
-	YAHOO_SERVICE_VERIFY,
-	YAHOO_SERVICE_P2PFILEXFER,
-	YAHOO_SERVICE_PEERTOPEER = 0x4F,	/* Checks if P2P possible */
-	YAHOO_SERVICE_WEBCAM,
-	YAHOO_SERVICE_AUTHRESP = 0x54,
-	YAHOO_SERVICE_LIST,
-	YAHOO_SERVICE_AUTH = 0x57,
-	YAHOO_SERVICE_AUTHBUDDY = 0x6d,
-	YAHOO_SERVICE_ADDBUDDY = 0x83,
-	YAHOO_SERVICE_REMBUDDY,
-	YAHOO_SERVICE_IGNORECONTACT,	/* > 1, 7, 13 < 1, 66, 13, 0*/
-	YAHOO_SERVICE_REJECTCONTACT,
-	YAHOO_SERVICE_GROUPRENAME = 0x89, /* > 1, 65(new), 66(0), 67(old) */
-	YAHOO_SERVICE_Y7_PING = 0x8A, /* 0 - id and that's it?? */
-	YAHOO_SERVICE_CHATONLINE = 0x96, /* > 109(id), 1, 6(abcde) < 0,1*/
-	YAHOO_SERVICE_CHATGOTO,
-	YAHOO_SERVICE_CHATJOIN,	/* > 1 104-room 129-1600326591 62-2 */
-	YAHOO_SERVICE_CHATLEAVE,
-	YAHOO_SERVICE_CHATEXIT = 0x9b,
-	YAHOO_SERVICE_CHATADDINVITE = 0x9d,
-	YAHOO_SERVICE_CHATLOGOUT = 0xa0,
-	YAHOO_SERVICE_CHATPING,
-	YAHOO_SERVICE_COMMENT = 0xa8,
-	YAHOO_SERVICE_STEALTH = 0xb9,
-	YAHOO_SERVICE_PICTURE_CHECKSUM = 0xbd,
-	YAHOO_SERVICE_PICTURE = 0xbe,
-	YAHOO_SERVICE_PICTURE_UPDATE = 0xc1,
-	YAHOO_SERVICE_PICTURE_UPLOAD = 0xc2,
-	YAHOO_SERVICE_Y6_VISIBILITY=0xc5,
-	YAHOO_SERVICE_Y6_STATUS_UPDATE=0xc6,
-	YAHOO_PHOTOSHARE_INIT=0xd2,	
-	YAHOO_SERVICE_CONTACT_YMSG13=0xd6,
-	YAHOO_PHOTOSHARE_PREV=0xd7,
-	YAHOO_PHOTOSHARE_KEY=0xd8,
-	YAHOO_PHOTOSHARE_TRANS=0xda,
-	YAHOO_FILE_TRANSFER_INIT_YMSG13=0xdc,
-	YAHOO_FILE_TRANSFER_GET_YMSG13=0xdd,
-	YAHOO_FILE_TRANSFER_PUT_YMSG13=0xde,
-	YAHOO_SERVICE_YMSG15_STATUS=0xf0,
-	YAHOO_SERVICE_YMSG15_BUDDY_LIST=0xf1,
+struct connect_callback_data {
+	struct yahoo_data *yd;
+	int tag;
+	int i;
+	int server_i;
 };
 
@@ -242,13 +181,13 @@
 
 struct yahoo_search_state {
-	int   lsearch_type;
-	char  *lsearch_text;
-	int   lsearch_gender;
-	int   lsearch_agerange;
-	int   lsearch_photo;
-	int   lsearch_yahoo_only;
-	int   lsearch_nstart;
-	int   lsearch_nfound;
-	int   lsearch_ntotal;
+	int lsearch_type;
+	char *lsearch_text;
+	int lsearch_gender;
+	int lsearch_agerange;
+	int lsearch_photo;
+	int lsearch_yahoo_only;
+	int lsearch_nstart;
+	int lsearch_nfound;
+	int lsearch_ntotal;
 };
 
@@ -264,32 +203,50 @@
 	struct yahoo_search_state *ys;
 
-	int   fd;
+	void *fd;
 	enum yahoo_connection_type type;
-	
-	unsigned char	*rxqueue;
-	int   rxlen;
-	int   read_tag;
+
+	unsigned char *rxqueue;
+	int rxlen;
+	int read_tag;
 
 	YList *txqueues;
-	int   write_tag;
+	int write_tag;
 };
 
 struct yahoo_server_settings {
 	char *pager_host;
-	int   pager_port;
+	int pager_port;
 	char *filetransfer_host;
-	int   filetransfer_port;
+	int filetransfer_port;
 	char *webcam_host;
-	int   webcam_port;
+	int webcam_port;
 	char *webcam_description;
 	char *local_host;
-	int   conn_type;
+	int conn_type;
+	char **pager_host_list;
 };
 
-static void * _yahoo_default_server_settings()
-{
-	struct yahoo_server_settings *yss = y_new0(struct yahoo_server_settings, 1);
-
-	yss->pager_host = strdup(pager_host);
+static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over);
+
+static void yahoo_process_filetransfer(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+static void yahoo_process_filetransferinfo(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+static void yahoo_process_filetransferaccept(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+
+static void yahoo_https_auth(struct yahoo_input_data *yid, const char *seed, const char *sn);
+
+static void *_yahoo_default_server_settings()
+{
+	struct yahoo_server_settings *yss =
+		y_new0(struct yahoo_server_settings, 1);
+
+	/* Give preference to the default host list
+	 * Make sure that only one of the two is set at any time 
+	 */
+	yss->pager_host = NULL;
+	yss->pager_host_list = default_pager_hosts;
+
 	yss->pager_port = pager_port;
 	yss->filetransfer_host = strdup(filetransfer_host);
@@ -304,52 +261,59 @@
 }
 
-static void * _yahoo_assign_server_settings(va_list ap)
+static void *_yahoo_assign_server_settings(va_list ap)
 {
 	struct yahoo_server_settings *yss = _yahoo_default_server_settings();
 	char *key;
 	char *svalue;
-	int   nvalue;
-
-	while(1) {
+	int nvalue;
+	char **pvalue;
+
+	while (1) {
 		key = va_arg(ap, char *);
-		if(key == NULL)
-			break;
-
-		if(!strcmp(key, "pager_host")) {
+		if (key == NULL)
+			break;
+
+		if (!strcmp(key, "pager_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->pager_host);
 			yss->pager_host = strdup(svalue);
-		} else if(!strcmp(key, "pager_port")) {
+			yss->pager_host_list = NULL;
+		} else if (!strcmp(key, "pager_host_list")) {
+			pvalue = va_arg(ap, char **);
+			yss->pager_host_list = pvalue;
+			free(yss->pager_host);
+			yss->pager_host = NULL;
+		} else if (!strcmp(key, "pager_port")) {
 			nvalue = va_arg(ap, int);
 			yss->pager_port = nvalue;
-		} else if(!strcmp(key, "filetransfer_host")) {
+		} else if (!strcmp(key, "filetransfer_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->filetransfer_host);
 			yss->filetransfer_host = strdup(svalue);
-		} else if(!strcmp(key, "filetransfer_port")) {
+		} else if (!strcmp(key, "filetransfer_port")) {
 			nvalue = va_arg(ap, int);
 			yss->filetransfer_port = nvalue;
-		} else if(!strcmp(key, "webcam_host")) {
+		} else if (!strcmp(key, "webcam_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->webcam_host);
 			yss->webcam_host = strdup(svalue);
-		} else if(!strcmp(key, "webcam_port")) {
+		} else if (!strcmp(key, "webcam_port")) {
 			nvalue = va_arg(ap, int);
 			yss->webcam_port = nvalue;
-		} else if(!strcmp(key, "webcam_description")) {
+		} else if (!strcmp(key, "webcam_description")) {
 			svalue = va_arg(ap, char *);
 			free(yss->webcam_description);
 			yss->webcam_description = strdup(svalue);
-		} else if(!strcmp(key, "local_host")) {
+		} else if (!strcmp(key, "local_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->local_host);
 			yss->local_host = strdup(svalue);
-		} else if(!strcmp(key, "conn_type")) {
+		} else if (!strcmp(key, "conn_type")) {
 			nvalue = va_arg(ap, int);
 			yss->conn_type = nvalue;
 		} else {
 			WARNING(("Unknown key passed to yahoo_init, "
-				"perhaps you didn't terminate the list "
-				"with NULL"));
+					"perhaps you didn't terminate the list "
+					"with NULL"));
 		}
 	}
@@ -360,5 +324,5 @@
 static void yahoo_free_server_settings(struct yahoo_server_settings *yss)
 {
-	if(!yss)
+	if (!yss)
 		return;
 
@@ -372,7 +336,7 @@
 }
 
-static YList *conns=NULL;
-static YList *inputs=NULL;
-static int last_id=0;
+static YList *conns = NULL;
+static YList *inputs = NULL;
+static int last_id = 0;
 
 static void add_to_list(struct yahoo_data *yd)
@@ -380,14 +344,16 @@
 	conns = y_list_prepend(conns, yd);
 }
-static struct yahoo_data * find_conn_by_id(int id)
+
+static struct yahoo_data *find_conn_by_id(int id)
 {
 	YList *l;
-	for(l = conns; l; l = y_list_next(l)) {
+	for (l = conns; l; l = y_list_next(l)) {
 		struct yahoo_data *yd = l->data;
-		if(yd->client_id == id)
+		if (yd->client_id == id)
 			return yd;
 	}
 	return NULL;
 }
+
 static void del_from_list(struct yahoo_data *yd)
 {
@@ -396,4 +362,5 @@
 
 /* call repeatedly to get the next one */
+/*
 static struct yahoo_input_data * find_input_by_id(int id)
 {
@@ -406,15 +373,18 @@
 	return NULL;
 }
-
-static struct yahoo_input_data * find_input_by_id_and_webcam_user(int id, const char * who)
+*/
+
+static struct yahoo_input_data *find_input_by_id_and_webcam_user(int id,
+	const char *who)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_webcam_user"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->type == YAHOO_CONNECTION_WEBCAM && yid->yd->client_id == id 
-				&& yid->wcm && 
-				((who && yid->wcm->user && !strcmp(who, yid->wcm->user)) ||
-				 !(yid->wcm->user && !who)))
+		if (yid->type == YAHOO_CONNECTION_WEBCAM
+			&& yid->yd->client_id == id && yid->wcm && ((who
+					&& yid->wcm->user
+					&& !strcmp(who, yid->wcm->user))
+				|| !(yid->wcm->user && !who)))
 			return yid;
 	}
@@ -422,11 +392,12 @@
 }
 
-static struct yahoo_input_data * find_input_by_id_and_type(int id, enum yahoo_connection_type type)
+static struct yahoo_input_data *find_input_by_id_and_type(int id,
+	enum yahoo_connection_type type)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_type"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->type == type && yid->yd->client_id == id)
+		if (yid->type == type && yid->yd->client_id == id)
 			return yid;
 	}
@@ -434,11 +405,11 @@
 }
 
-static struct yahoo_input_data * find_input_by_id_and_fd(int id, int fd)
+static struct yahoo_input_data *find_input_by_id_and_fd(int id, void *fd)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_fd"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->fd == fd && yid->yd->client_id == id)
+		if (yid->fd == fd && yid->yd->client_id == id)
 			return yid;
 	}
@@ -448,10 +419,10 @@
 static int count_inputs_with_id(int id)
 {
-	int c=0;
+	int c = 0;
 	YList *l;
 	LOG(("counting %d", id));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->yd->client_id == id)
+		if (yid->yd->client_id == id)
 			c++;
 	}
@@ -460,16 +431,14 @@
 }
 
-
 extern char *yahoo_crypt(char *, char *);
 
 /* Free a buddy list */
-static void yahoo_free_buddies(YList * list)
+static void yahoo_free_buddies(YList *list)
 {
 	YList *l;
 
-	for(l = list; l; l = l->next)
-	{
+	for (l = list; l; l = l->next) {
 		struct yahoo_buddy *bud = l->data;
-		if(!bud)
+		if (!bud)
 			continue;
 
@@ -477,5 +446,5 @@
 		FREE(bud->id);
 		FREE(bud->real_name);
-		if(bud->yab_entry) {
+		if (bud->yab_entry) {
 			FREE(bud->yab_entry->fname);
 			FREE(bud->yab_entry->lname);
@@ -496,5 +465,5 @@
 
 /* Free an identities list */
-static void yahoo_free_identities(YList * list)
+static void yahoo_free_identities(YList *list)
 {
 	while (list) {
@@ -525,4 +494,5 @@
 	FREE(yd->cookie_y);
 	FREE(yd->cookie_t);
+	FREE(yd->cookie_b);
 	FREE(yd->cookie_c);
 	FREE(yd->login_cookie);
@@ -540,6 +510,6 @@
 #define YAHOO_PACKET_HDRLEN (4 + 2 + 2 + 2 + 2 + 4 + 4)
 
-static struct yahoo_packet *yahoo_packet_new(enum yahoo_service service, 
-		enum yahoo_status status, int id)
+static struct yahoo_packet *yahoo_packet_new(enum yahoo_service service,
+	enum ypacket_status status, int id)
 {
 	struct yahoo_packet *pkt = y_new0(struct yahoo_packet, 1);
@@ -552,5 +522,6 @@
 }
 
-static void yahoo_packet_hash(struct yahoo_packet *pkt, int key, const char *value)
+static void yahoo_packet_hash(struct yahoo_packet *pkt, int key,
+	const char *value)
 {
 	struct yahoo_pair *pair = y_new0(struct yahoo_pair, 1);
@@ -597,5 +568,6 @@
 			 (((*((buf)+3))&0xff)))
 
-static void yahoo_packet_read(struct yahoo_packet *pkt, unsigned char *data, int len)
+static void yahoo_packet_read(struct yahoo_packet *pkt, unsigned char *data,
+	int len)
 {
 	int pos = 0;
@@ -650,5 +622,6 @@
 			FREE(value);
 			pkt->hash = y_list_append(pkt->hash, pair);
-			DEBUG_MSG(("Key: %d  \tValue: %s", pair->key, pair->value));
+			DEBUG_MSG(("Key: %d  \tValue: %s", pair->key,
+					pair->value));
 		} else {
 			FREE(pair);
@@ -690,28 +663,27 @@
 }
 
-
 static void yahoo_packet_dump(unsigned char *data, int len)
 {
-	if(yahoo_get_log_level() >= YAHOO_LOG_DEBUG) {
+	if (yahoo_get_log_level() >= YAHOO_LOG_DEBUG) {
 		int i;
 		for (i = 0; i < len; i++) {
 			if ((i % 8 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)(" ");
+				YAHOO_CALLBACK(ext_yahoo_log) (" ");
 			if ((i % 16 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)("\n");
-			YAHOO_CALLBACK(ext_yahoo_log)("%02x ", data[i]);
-		}
-		YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) ("\n");
+			YAHOO_CALLBACK(ext_yahoo_log) ("%02x ", data[i]);
+		}
+		YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 		for (i = 0; i < len; i++) {
 			if ((i % 8 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)(" ");
+				YAHOO_CALLBACK(ext_yahoo_log) (" ");
 			if ((i % 16 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 			if (isprint(data[i]))
-				YAHOO_CALLBACK(ext_yahoo_log)(" %c ", data[i]);
+				YAHOO_CALLBACK(ext_yahoo_log) (" %c ", data[i]);
 			else
-				YAHOO_CALLBACK(ext_yahoo_log)(" . ");
-		}
-		YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) (" . ");
+		}
+		YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 	}
 }
@@ -723,5 +695,6 @@
 }
 
-static void yahoo_add_to_send_queue(struct yahoo_input_data *yid, void *data, int length)
+static void yahoo_add_to_send_queue(struct yahoo_input_data *yid, void *data,
+	int length)
 {
 	struct data_queue *tx = y_new0(struct data_queue, 1);
@@ -732,13 +705,15 @@
 	yid->txqueues = y_list_append(yid->txqueues, tx);
 
-	if(!yid->write_tag)
-		yid->write_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, yid->fd, YAHOO_INPUT_WRITE, yid);
-}
-
-static void yahoo_send_packet(struct yahoo_input_data *yid, struct yahoo_packet *pkt, int extra_pad)
+	if (!yid->write_tag)
+		yid->write_tag =
+			YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->
+			client_id, yid->fd, YAHOO_INPUT_WRITE, yid);
+}
+
+static void yahoo_send_packet(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt, int extra_pad)
 {
 	int pktlen = yahoo_packet_length(pkt);
 	int len = YAHOO_PACKET_HDRLEN + pktlen;
-
 	unsigned char *data;
 	int pos = 0;
@@ -749,17 +724,18 @@
 	data = y_new0(unsigned char, len + 1);
 
-	memcpy(data + pos, "YMSG", 4); pos += 4;
-	pos += yahoo_put16(data + pos, YAHOO_PROTO_VER);
-	pos += yahoo_put16(data + pos, 0x0000);
-	pos += yahoo_put16(data + pos, pktlen + extra_pad);
-	pos += yahoo_put16(data + pos, pkt->service);
-	pos += yahoo_put32(data + pos, pkt->status);
-	pos += yahoo_put32(data + pos, pkt->id);
+	memcpy(data + pos, "YMSG", 4);
+	pos += 4;
+	pos += yahoo_put16(data + pos, YAHOO_PROTO_VER);	/* version [latest 12 0x000c] */
+	pos += yahoo_put16(data + pos, 0x0000);	/* HIWORD pkt length??? */
+	pos += yahoo_put16(data + pos, pktlen + extra_pad);	/* LOWORD pkt length? */
+	pos += yahoo_put16(data + pos, pkt->service);	/* service */
+	pos += yahoo_put32(data + pos, pkt->status);	/* status [4bytes] */
+	pos += yahoo_put32(data + pos, pkt->id);	/* session [4bytes] */
 
 	yahoo_packet_write(pkt, data + pos);
 
 	yahoo_packet_dump(data, len);
-	
-	if( yid->type == YAHOO_CONNECTION_FT )
+
+	if (yid->type == YAHOO_CONNECTION_FT)
 		yahoo_send_data(yid->fd, data, len);
 	else
@@ -782,10 +758,10 @@
 }
 
-static int yahoo_send_data(int fd, void *data, int len)
+static int yahoo_send_data(void *fd, void *data, int len)
 {
 	int ret;
 	int e;
 
-	if (fd < 0)
+	if (fd == NULL)
 		return -1;
 
@@ -793,9 +769,9 @@
 
 	do {
-		ret = write(fd, data, len);
-	} while(ret == -1 && errno==EINTR);
-	e=errno;
-
-	if (ret == -1)  {
+		ret = YAHOO_CALLBACK(ext_yahoo_write) (fd, data, len);
+	} while (ret == -1 && errno == EINTR);
+	e = errno;
+
+	if (ret == -1) {
 		LOG(("wrote data: ERR %s", strerror(errno)));
 	} else {
@@ -803,13 +779,12 @@
 	}
 
-	errno=e;
+	errno = e;
 	return ret;
 }
 
-void yahoo_close(int id) 
+void yahoo_close(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	
-	if(!yd)
+	if (!yd)
 		return;
 
@@ -817,29 +792,31 @@
 
 	yahoo_free_data(yd);
-	if(id == last_id)
+	if (id == last_id)
 		last_id--;
 }
 
-static void yahoo_input_close(struct yahoo_input_data *yid) 
+static void yahoo_input_close(struct yahoo_input_data *yid)
 {
 	inputs = y_list_remove(inputs, yid);
 
-	LOG(("yahoo_input_close(read)")); 
-	YAHOO_CALLBACK(ext_yahoo_remove_handler)(yid->yd->client_id, yid->read_tag);
-	LOG(("yahoo_input_close(write)")); 
-	YAHOO_CALLBACK(ext_yahoo_remove_handler)(yid->yd->client_id, yid->write_tag);
+	LOG(("yahoo_input_close(read)"));
+	YAHOO_CALLBACK(ext_yahoo_remove_handler) (yid->yd->client_id,
+		yid->read_tag);
+	LOG(("yahoo_input_close(write)"));
+	YAHOO_CALLBACK(ext_yahoo_remove_handler) (yid->yd->client_id,
+		yid->write_tag);
 	yid->read_tag = yid->write_tag = 0;
-	if(yid->fd)
-		close(yid->fd);
+	if (yid->fd)
+		YAHOO_CALLBACK(ext_yahoo_close) (yid->fd);
 	yid->fd = 0;
 	FREE(yid->rxqueue);
-	if(count_inputs_with_id(yid->yd->client_id) == 0) {
+	if (count_inputs_with_id(yid->yd->client_id) == 0) {
 		LOG(("closing %d", yid->yd->client_id));
 		yahoo_close(yid->yd->client_id);
 	}
 	yahoo_free_webcam(yid->wcm);
-	if(yid->wcd)
+	if (yid->wcd)
 		FREE(yid->wcd);
-	if(yid->ys) {
+	if (yid->ys) {
 		FREE(yid->ys->lsearch_text);
 		FREE(yid->ys);
@@ -848,5 +825,6 @@
 }
 
-static int is_same_bud(const void * a, const void * b) {
+static int is_same_bud(const void *a, const void *b)
+{
 	const struct yahoo_buddy *subject = a;
 	const struct yahoo_buddy *object = b;
@@ -855,17 +833,17 @@
 }
 
-static char * getcookie(char *rawcookie)
-{
-	char * cookie=NULL;
-	char * tmpcookie; 
-	char * cookieend;
-
-	if (strlen(rawcookie) < 2) 
+static char *getcookie(char *rawcookie)
+{
+	char *cookie = NULL;
+	char *tmpcookie;
+	char *cookieend;
+
+	if (strlen(rawcookie) < 2)
 		return NULL;
 
-	tmpcookie = strdup(rawcookie+2);
+	tmpcookie = strdup(rawcookie + 2);
 	cookieend = strchr(tmpcookie, ';');
 
-	if(cookieend)
+	if (cookieend)
 		*cookieend = '\0';
 
@@ -877,5 +855,5 @@
 }
 
-static char * getlcookie(char *cookie)
+static char *getlcookie(char *cookie)
 {
 	char *tmp;
@@ -884,9 +862,9 @@
 
 	tmpend = strstr(cookie, "n=");
-	if(tmpend) {
-		tmp = strdup(tmpend+2);
+	if (tmpend) {
+		tmp = strdup(tmpend + 2);
 		tmpend = strchr(tmp, '&');
-		if(tmpend)
-			*tmpend='\0';
+		if (tmpend)
+			*tmpend = '\0';
 		login_cookie = strdup(tmp);
 		FREE(tmp);
@@ -896,5 +874,6 @@
 }
 
-static void yahoo_process_notify(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_notify(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -927,13 +906,15 @@
 	if (!msg)
 		return;
-	
-	if (!strncasecmp(msg, "TYPING", strlen("TYPING"))) 
-		YAHOO_CALLBACK(ext_yahoo_typing_notify)(yd->client_id, to, from, stat);
-	else if (!strncasecmp(msg, "GAME", strlen("GAME"))) 
-		YAHOO_CALLBACK(ext_yahoo_game_notify)(yd->client_id, to, from, stat);
-	else if (!strncasecmp(msg, "WEBCAMINVITE", strlen("WEBCAMINVITE"))) 
-	{
+
+	if (!strncasecmp(msg, "TYPING", strlen("TYPING")))
+		YAHOO_CALLBACK(ext_yahoo_typing_notify) (yd->client_id, to,
+			from, stat);
+	else if (!strncasecmp(msg, "GAME", strlen("GAME")))
+		YAHOO_CALLBACK(ext_yahoo_game_notify) (yd->client_id, to, from,
+			stat, ind);
+	else if (!strncasecmp(msg, "WEBCAMINVITE", strlen("WEBCAMINVITE"))) {
 		if (!strcmp(ind, " ")) {
-			YAHOO_CALLBACK(ext_yahoo_webcam_invite)(yd->client_id, to, from);
+			YAHOO_CALLBACK(ext_yahoo_webcam_invite) (yd->client_id,
+				to, from);
 		} else {
 			accept = atoi(ind);
@@ -941,68 +922,13 @@
 			if (accept < 0)
 				accept = 0;
-			YAHOO_CALLBACK(ext_yahoo_webcam_invite_reply)(yd->client_id, to, from, accept);
-		}
-	}
-	else
+			YAHOO_CALLBACK(ext_yahoo_webcam_invite_reply) (yd->
+				client_id, to, from, accept);
+		}
+	} else
 		LOG(("Got unknown notification: %s", msg));
 }
 
-static void yahoo_process_filetransfer(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
-{
-	struct yahoo_data *yd = yid->yd;
-	char *from=NULL;
-	char *to=NULL;
-	char *msg=NULL;
-	char *url=NULL;
-	long expires=0;
-
-	char *service=NULL;
-
-	char *filename=NULL;
-	unsigned long filesize=0L;
-
-	YList *l;
-	for (l = pkt->hash; l; l = l->next) {
-		struct yahoo_pair *pair = l->data;
-		if (pair->key == 4)
-			from = pair->value;
-		if (pair->key == 5)
-			to = pair->value;
-		if (pair->key == 14)
-			msg = pair->value;
-		if (pair->key == 20)
-			url = pair->value;
-		if (pair->key == 38)
-			expires = atol(pair->value);
-
-		if (pair->key == 27)
-			filename = pair->value;
-		if (pair->key == 28)
-			filesize = atol(pair->value);
-
-		if (pair->key == 49)
-			service = pair->value;
-	}
-
-	if(pkt->service == YAHOO_SERVICE_P2PFILEXFER) {
-		if(strcmp("FILEXFER", service) != 0) {
-			WARNING(("unhandled service 0x%02x", pkt->service));
-			yahoo_dump_unhandled(pkt);
-			return;
-		}
-	}
-
-	if(msg) {
-		char *tmp;
-		tmp = strchr(msg, '\006');
-		if(tmp)
-			*tmp = '\0';
-	}
-	if(url && from)
-		YAHOO_CALLBACK(ext_yahoo_got_file)(yd->client_id, to, from, url, expires, msg, filename, filesize);
-
-}
-
-static void yahoo_process_conference(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_conference(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1012,23 +938,23 @@
 	char *room = NULL;
 	char *id = NULL;
-	int  utf8 = 0;
+	int utf8 = 0;
 	YList *members = NULL;
 	YList *l;
-	
+
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 50)
 			host = pair->value;
-		
-		if (pair->key == 52) {		/* invite */
+
+		if (pair->key == 52) {	/* invite */
 			members = y_list_append(members, strdup(pair->value));
 		}
-		if (pair->key == 53)		/* logon */
+		if (pair->key == 53)	/* logon */
 			who = pair->value;
-		if (pair->key == 54)		/* decline */
+		if (pair->key == 54)	/* decline */
 			who = pair->value;
-		if (pair->key == 55)		/* unavailable (status == 2) */
+		if (pair->key == 55)	/* unavailable (status == 2) */
 			who = pair->value;
-		if (pair->key == 56)		/* logoff */
+		if (pair->key == 56)	/* logoff */
 			who = pair->value;
 
@@ -1036,17 +962,16 @@
 			room = pair->value;
 
-		if (pair->key == 58)		/* join message */
+		if (pair->key == 58)	/* join message */
 			msg = pair->value;
-		if (pair->key == 14)		/* decline/conf message */
+		if (pair->key == 14)	/* decline/conf message */
 			msg = pair->value;
 
-		if (pair->key == 13)
-			;
-		if (pair->key == 16)		/* error */
+		if (pair->key == 13) ;
+		if (pair->key == 16)	/* error */
 			msg = pair->value;
 
-		if (pair->key == 1)		/* my id */
+		if (pair->key == 1)	/* my id */
 			id = pair->value;
-		if (pair->key == 3)		/* message sender */
+		if (pair->key == 3)	/* message sender */
 			who = pair->value;
 
@@ -1055,53 +980,58 @@
 	}
 
-	if(!room)
-		return;
-
-	if(host) {
-		for(l = members; l; l = l->next) {
-			char * w = l->data;
-			if(!strcmp(w, host))
+	if (!room)
+		return;
+
+	if (host) {
+		for (l = members; l; l = l->next) {
+			char *w = l->data;
+			if (!strcmp(w, host))
 				break;
 		}
-		if(!l)
+		if (!l)
 			members = y_list_append(members, strdup(host));
 	}
 	/* invite, decline, join, left, message -> status == 1 */
 
-	switch(pkt->service) {
+	switch (pkt->service) {
 	case YAHOO_SERVICE_CONFINVITE:
-		if(pkt->status == 2)
-			;
-		else if(members)
-			YAHOO_CALLBACK(ext_yahoo_got_conf_invite)(yd->client_id, id, host, room, msg, members);
-		else if(msg)
-			YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, msg, 0, E_CONFNOTAVAIL);
+		if (pkt->status == 2) ;
+		else if (members)
+			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->
+				client_id, id, host, room, msg, members);
+		else if (msg)
+			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, msg, 0,
+				E_CONFNOTAVAIL);
 		break;
 	case YAHOO_SERVICE_CONFADDINVITE:
-		if(pkt->status == 2)
-			;
-		else
-			YAHOO_CALLBACK(ext_yahoo_got_conf_invite)(yd->client_id, id, host, room, msg, members);
+		if (pkt->status == 1)
+			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->
+				client_id, id, host, room, msg, members);
 		break;
 	case YAHOO_SERVICE_CONFDECLINE:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userdecline)(yd->client_id, id, who, room, msg);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userdecline) (yd->
+				client_id, id, who, room, msg);
 		break;
 	case YAHOO_SERVICE_CONFLOGON:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userjoin)(yd->client_id, id, who, room);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userjoin) (yd->client_id,
+				id, who, room);
 		break;
 	case YAHOO_SERVICE_CONFLOGOFF:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userleave)(yd->client_id, id, who, room);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userleave) (yd->client_id,
+				id, who, room);
 		break;
 	case YAHOO_SERVICE_CONFMSG:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_message)(yd->client_id, id, who, room, msg, utf8);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_message) (yd->client_id,
+				id, who, room, msg, utf8);
 		break;
 	}
 }
 
-static void yahoo_process_chat(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_chat(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *msg = NULL;
@@ -1112,11 +1042,11 @@
 	YList *members = NULL;
 	struct yahoo_chat_member *currentmember = NULL;
-	int  msgtype = 1;
-	int  utf8 = 0;
-	int  firstjoin = 0;
-	int  membercount = 0;
-	int  chaterr=0;
+	int msgtype = 1;
+	int utf8 = 0;
+	int firstjoin = 0;
+	int membercount = 0;
+	int chaterr = 0;
 	YList *l;
-	
+
 	yahoo_dump_unhandled(pkt);
 	for (l = pkt->hash; l; l = l->next) {
@@ -1148,5 +1078,6 @@
 
 			if (pkt->service == YAHOO_SERVICE_CHATJOIN) {
-				currentmember = y_new0(struct yahoo_chat_member, 1);
+				currentmember =
+					y_new0(struct yahoo_chat_member, 1);
 				currentmember->id = strdup(pair->value);
 				members = y_list_append(members, currentmember);
@@ -1178,5 +1109,4 @@
 		}
 
-
 		if (pair->key == 130) {
 			/* first join */
@@ -1196,17 +1126,19 @@
 			/* message error not sure what all the pair values mean */
 			/* but -1 means no session in room */
-			chaterr= atoi(pair->value);
-		}
-	}
-
-	if(!room) {
-		if (pkt->service == YAHOO_SERVICE_CHATLOGOUT) { /* yahoo originated chat logout */
-			YAHOO_CALLBACK(ext_yahoo_chat_yahoologout)(yid->yd->client_id, id);
-			return ;
-		}
-		if (pkt->service == YAHOO_SERVICE_COMMENT && chaterr)  {
-			YAHOO_CALLBACK(ext_yahoo_chat_yahooerror)(yid->yd->client_id, id);
+			chaterr = atoi(pair->value);
+		}
+	}
+
+	if (!room) {
+		if (pkt->service == YAHOO_SERVICE_CHATLOGOUT) {	/* yahoo originated chat logout */
+			YAHOO_CALLBACK(ext_yahoo_chat_yahoologout) (yid->yd->
+				client_id, id);
 			return;
 		}
+		if (pkt->service == YAHOO_SERVICE_COMMENT && chaterr) {
+			YAHOO_CALLBACK(ext_yahoo_chat_yahooerror) (yid->yd->
+				client_id, id);
+			return;
+		}
 
 		WARNING(("We didn't get a room name, ignoring packet"));
